Index: pkg-nagios-plugins-contrib/dsa/checks/dsa-check-running-kernel
===================================================================
--- pkg-nagios-plugins-contrib.orig/dsa/checks/dsa-check-running-kernel
+++ pkg-nagios-plugins-contrib/dsa/checks/dsa-check-running-kernel
@@ -132,7 +132,7 @@ cat_vmlinux() {
 	filter="$3"
 	hdroff="$4"
 
-	if ! which $filter >/dev/null; then
+	if ! which ${filter%% *} >/dev/null; then
 		echo "UNKNOWN: filter command '$filter' missing, perhaps install xz-utils, lz4 or lzop?" >&2
 		exit $UNKNOWN
 	fi
@@ -157,7 +157,11 @@ get_image_linux() {
 	cat_vmlinux "$image" "\x00\x00\x00\x02\xff"  "xzcat" -1
 	cat_vmlinux "$image" "\x00\x00\x00\x04\xff"  "xzcat" -1
 	# xz compressed image
-	cat_vmlinux "$image" "\xfd\x37\x7a\x58\x5a " "xzcat"  0
+	cat_vmlinux "$image" "\xfd\x37\x7a\x58\x5a"  "xzcat"  0
+	# lz4 compressed image
+	cat_vmlinux "$image" "\x02\x21\x4c\x18"  "lz4 -dc"  0
+	# lzo compressed image
+	cat_vmlinux "$image" "\x89\x4c\x5a\x4f\x00\x0d\x0a\x1a"  "lzop -dc"  0
 
 	echo "ERROR: Unable to extract kernel image." 2>&1
 	exit 1
